#ifndef _MITTELFELD_H_
#define _MITTELFELD_H_

class Mittelfeld :  public vW_Behaviour {
protected:
    bool vorgelegt;
    Time vorgelegt_Time;
    void Offense();
    void Defense();
    Vector PointToDribbleTo();
    bool lazy_dribbling();
    bool should_dribble();
 public:
    void Behave();
    Mittelfeld()
	{
	    MyStartPosition=Vector(-15,0);
	};
};

class DMittelfeld : public Mittelfeld{
 protected:
    void Offense();
    void Defense();    
    void BallWithMe();
    Vector GoodPositionToReceiveBall(int x=-10);
 public:
    void Behave();
    DMittelfeld()
	{
	    MyStartPosition=Vector(-20,0);
	};
    
};

class OMittelfeld : public Mittelfeld{
 protected:
  void Offense();
  void Defense();
    void BallWithMe();
 public:
  void Behave();
  OMittelfeld()
	{
	    MyStartPosition=Vector(-10,0);
	};
    
};


class Herzog : public OMittelfeld {
 public:
    void Behave();    
    Herzog()
	{
	    MyStartPosition=Vector(-10,0);
	};
};


class Bode : public OMittelfeld {
 public:
    void Behave();
    Bode()
	{
	    MyStartPosition=Vector(-10,-10);
	};
};


class Maximov : public OMittelfeld {
 public:
    void Behave();
    Maximov()
	{
	    MyStartPosition=Vector(-10,10);
	};
};


class Schierenbeck : public Mittelfeld {
 public:
    void Behave();
    Schierenbeck()
	{
	    MyStartPosition=Vector(-12,-25);
	};
};


class Trares : public DMittelfeld {
 public:
    void Behave();
    Trares()
	{
	    MyStartPosition=Vector(-20,-10);
	};
};


class Frey : public DMittelfeld {
 public:
    void Behave();
    Frey()
	{
	    MyStartPosition=Vector(-20,10);
	};
};

class Eilts : public DMittelfeld {
 public:
    void Behave();
    Eilts()
	{
	    MyStartPosition=Vector(-20,0);
	};
};

class Dabrowski : public Mittelfeld {
 public:
    void Behave();
    Dabrowski()
	{
	    MyStartPosition=Vector(-12,25);
	};
};

#endif//  _MITTELFELD_H_

