#include "vW_stuermer.h"


void Stuermer::Behave()
{
    onStartPos=false;
    if (!Mem->MyConf()) {
	Mem->LogAction2(10, "Don't know where I am, scanning field");
	    Mem->update_offside_lines();
	    scan_field_with_body();
	    return;
    }
    if (Mem->BallPositionValid())
    {
	Mem->update_offside_lines();
	if (Mem->MyNumber == 
	    Mem->ClosestTeammateTo(Mem->BallAbsolutePosition()))
	{
	    say("");
	}
	if(Mem->PlayMode== PM_My_Kick_In || Mem->PlayMode==PM_My_Corner_Kick){
	    if(Mem->MyNumber == Mem->ClosestTeammateToBall())
		kick_in();
	    else 
		BallWithMyTeam();
	    return;
	}
	if (Mem->BallKickable() ){
	    BallWithMe();
	} 
	else 
	{
	    Vector ball = Mem->BallAbsolutePosition();
	    if(Mem->PlayMode!=PM_Play_On||
		(Mem->OpponentPositionValid(Mem->ClosestOpponentToBall())&&
		 Mem->TeammatePositionValid(Mem->ClosestTeammateToBall()) &&
		 Mem->TeammateDistanceTo(Mem->ClosestTeammateToBall(),ball)<=
		 Mem->OpponentDistanceTo(Mem->ClosestOpponentToBall(),ball)))
		BallWithMyTeam();
	    else{
		vorgelegt=false;
		BallNotWithMyTeam();
	    }
	    
	}
    } else {
	float x = 0;
	Unum num1=0;
	Unum num2=0;
	for(int i=1; i<=Mem->SP_team_size; i++){
	    if(Mem->OpponentPositionValid(i) && Mem->OpponentAbsolutePosition(i).x>x)
	    {
		x=Mem->OpponentAbsolutePosition(i).x;
		num1=num2;
		num2=i;
	    }
	}
	if(num1){
	    go_to_point(Vector(Mem->OpponentAbsolutePosition(num1).x-5,MyStartPosition.y),0,25,DT_none);
	    scan_field_with_neck();
	}
	else
	    scan_field_with_body();
    }
}

void Stuermer::BallWithMe()
{
  Mem->team_receiver=0;
    if(goodPointToScore()){
	vorgelegt =false;
	Score();
	return;
    }
    if(Mem->BallVelocityValid() && Mem->BallAbsoluteVelocity().mod()>2 &&
       !vorgelegt){
	stop_ball();
        vorgelegt=true;
	return;
    }
    Unum TeammateToPassBall=findTeammateToPassBall();
    if(TeammateToPassBall){
        vorgelegt=false;
	pass_ball(TeammateToPassBall);
	return;
    }
    if(Mem->MyPos().x>40&&fabs(Mem->MyPos().y)>20){
	vorgelegt=false;
	kick_ball(Mem->MarkerAngleFromBody(Mem->RM_Their_PC_Flag),
		  Mem->BestKickMode(Mem->MarkerAngleFromBody(Mem->RM_Their_PC_Flag)));
	return;
    }
    if(Mem->BallAbsolutePosition().x>Mem->MyPos().x){
	vorgelegt=true;
	AngleDeg KickAngle=AngleToKickBall();
	int Power=kickPower(Mem->AngleToFromBody(KickAngle));
//	if(Mem->TheirPenaltyArea.IsWithin(Mem->MyPos())||
//	   Mem->MyPos().x>Mem->MarkerX(Mem->RM_Their_PC_Flag)||Power<10){
	    if(lazy_or_strict())
		// DribbleTo(PointToGo(),100,1,5, DM_Lazy);
                 SmartDribbleTo(Vector(50,MyStartPosition.y),75,1);
	    else
		// DribbleTo(PointToGo(),75,1,5, DM_Strict);
		SmartDribbleTo(Vector(50,MyStartPosition.y),100,1);
/*	} else {
	  if(Power==26)
	    kick(10,Mem->AngleToFromBody(Vector(Mem->MyPos().x,-Mem->MyPos().y)));
	  else{
	    if(Power==27)
	      kick(25,0);
	    else{
	      kick(Power,KickAngle);
	      scan_field_with_neck();
	    }
	  }
	}
*/	
	
    }
    else{
	DribbleRes res =  SmartDribbleTo(Mem->TheirRightGoalKickSpot,75,1);
         // SimpleDribbleTo(Mem->TheirRightGoalKickSpot);
	if(res ==  DR_GotThere)
	    kick(100,Mem->MarkerAngleFromBody(Mem->RM_Their_Goal));
    }
}

bool Stuermer::lazy_or_strict(){	   
    if(Mem->NumOpponentsInCone(5,Mem->MyPos()+Vector(5,0),Mem->MyPos()))
	return false;
    else
	return true;
}

bool Stuermer::dribbeln(){
    if(Mem->TheirPenaltyArea.IsWithin(Mem->MyPos())||
       Mem->MyPos().x>Mem->MarkerX(Mem->RM_Their_PC_Flag)||
       (Mem->NumOpponentsWithin(20,50)&&!Mem->NumOpponentsWithin(Mem->SP_kickable_area))){
	cout << Mem->NumOpponentsWithin(20,50) << endl;
	return true;
    }
    
    else
	return false;
}

int Stuermer::kickPower(AngleDeg KickAngle)
{
    float dist=DistanceToNextOpponentInCone(1
					    ,Mem->MyPos()+Vector(20,0).rotate(Mem->MyBodyAng()+KickAngle) 
					    ,Mem->MyPos())*2;
    if(!Mem->NumOpponentsWithin(Mem->SP_kickable_area))
	return int(dist>25?25:dist);
    else 
      if(Mem->OpponentPositionValid(Mem->ClosestOpponentToBall())&&
	 Mem->OpponentAbsolutePosition(Mem->ClosestOpponentToBall()).x>Mem->MyPos().x)
	return 26;
      else
	return 27;
}

Vector Stuermer::PointToGo()
{
    Vector MyPos=Mem->MyPos();
    Vector pos=Mem->MyPos()+Vector(30,0);
    Vector ziel=pos;
    int eval=0;
    eval=Mem->NumOpponentsInCone(1,pos,MyPos);
    pos=Mem->MyPos()+Vector(15,15);
    if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
	eval=Mem->NumOpponentsInCone(1,pos,MyPos);
	ziel=pos;
    }
    pos=Mem->MyPos()+Vector(15,-15);
    if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
	eval=Mem->NumOpponentsInCone(1,pos,MyPos);
	ziel=pos;
	
    }
    pos=Mem->MyPos()+Vector(0,30);
    if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
	eval=Mem->NumOpponentsInCone(1,pos,MyPos);
	ziel=pos;
	
    }
    pos=Mem->MyPos()+Vector(0,-30);
    if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
	eval=Mem->NumOpponentsInCone(1,pos,MyPos);
	ziel=pos;
	
    }
   return ziel;
}

AngleDeg  Stuermer::AngleToKickBall()
{
    Vector MyPos=Mem->MyPos();
    Vector pos=Mem->MyPos()+Vector(40,0);
    AngleDeg ziel=Mem->AngleToFromBody(pos);    
    int eval=Mem->NumOpponentsInCone(1,pos,MyPos)-1;
    pos=Mem->MyPos()+Vector(20,20);
    if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
	eval=Mem->NumOpponentsInCone(1,pos,MyPos);
	ziel=Mem->AngleToFromBody(pos);
    }
    pos=Mem->MyPos()+Vector(20,-20);
    if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
	eval=Mem->NumOpponentsInCone(1,pos,MyPos);
	ziel=Mem->AngleToFromBody(pos);
    }
    pos=Mem->MyPos()+Vector(0,40);
    if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
	eval=Mem->NumOpponentsInCone(1,pos,MyPos);
	ziel=Mem->AngleToFromBody(pos);
    }
    pos=Mem->MyPos()+Vector(0,-40);
    if(eval>Mem->NumOpponentsInCone(1,pos,MyPos)){
	eval=Mem->NumOpponentsInCone(1,pos,MyPos);
	ziel=Mem->AngleToFromBody(pos);
    }
    return ziel;
}

void  Stuermer::BallWithMyTeam()
{
    if(Mem->PlayMode!=PM_My_Goalie_Free_Kick&& Mem->PlayMode!=PM_My_Offside_Kick&&
       (Mem->NumTeammatesCloserToBall()<1 || Mem->team_receiver==Mem->MyNumber)){
	getBall();
    } else {
	if(Mem->my_offside_line<Mem->MyPos().x)
	    if(Mem->PlayMode!=PM_Play_On)
		go_to_point(Mem->MyPos()-Vector(5,0),0,25,DT_none);
	    else
		go_to_point(Mem->MyPos()-Vector(10,0),0,100,DT_none);
	else{
	    vorgelegt=false;
	    BestPositionToReceiveBall=GoodPositionToReceiveBall(10);
	    if(BestPositionToReceiveBall.x<0)
		BestPositionToReceiveBall=MyStartPosition;
	    if(fabs(BestPositionToReceiveBall.dist(Mem->MyPos())>5)){
		if(!Mem->BallPositionValid()) scan_field_with_neck();
		else
		    face_only_neck_to_ball();
		if(BestPositionToReceiveBall.x>Mem->MyPos().x)
		    if(Mem->PlayMode!=PM_Play_On)
			go_to_point(BestPositionToReceiveBall,0,25,DT_none);
		    else
			go_to_point(BestPositionToReceiveBall,0,75,DT_all);
		else
		    if(Mem->MyPos().x>Mem->my_offside_line)
			if(Mem->PlayMode!=PM_Play_On)
			    go_to_point(BestPositionToReceiveBall,0,25,DT_none);
			else
			    go_to_point(BestPositionToReceiveBall,0,100,DT_all);
		    else
			go_to_point(BestPositionToReceiveBall,0,25,DT_all);		    
	    } else {
		face_neck_and_body_to_ball();
	    }
	}
    }
}

void Stuermer::BallNotWithMyTeam() 
{
    vorgelegt=false;
    if(Mem->team_receiver == Mem->MyNumber){
	getBall();
	return;
    }
    if(Mem->NumTeammatesCloserToBall()<1)
	getBall();
    else
	if(Mem->my_offside_line<Mem->MyPos().x)
	    if(Mem->PlayMode!=PM_Play_On)
		go_to_point(Mem->MyPos()-Vector(5,0),0,25,DT_none);
	    else
		go_to_point(Mem->MyPos()-Vector(10,0),0,100,DT_none);
	else{
	    vorgelegt=false;
	    BestPositionToReceiveBall=GoodPositionToReceiveBall(10);
	    if(BestPositionToReceiveBall.x<0)
		BestPositionToReceiveBall=MyStartPosition;
	    if(fabs(BestPositionToReceiveBall.dist(Mem->MyPos())>5)){
		if(!Mem->BallPositionValid()) scan_field_with_neck();
		else
		    face_only_neck_to_ball();
		if(BestPositionToReceiveBall.x>Mem->MyPos().x)
		    if(Mem->PlayMode!=PM_Play_On)
			go_to_point(BestPositionToReceiveBall,0,25,DT_none);
		    else
			go_to_point(BestPositionToReceiveBall,0,75,DT_all);
		else
		    if(Mem->MyPos().x>Mem->my_offside_line)
			if(Mem->PlayMode!=PM_Play_On)
			    go_to_point(BestPositionToReceiveBall,0,25,DT_none);
			else
			    go_to_point(BestPositionToReceiveBall,0,100,DT_all);
		    else
			go_to_point(BestPositionToReceiveBall,0,25,DT_all);		    
	    } else {
		face_neck_and_body_to_ball();
	    }
	}
}


void Ailton::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	if(onStartPos)
	    scan_field_with_body();
	else{
	    onStartPos=true;
	    move(-1,10);
	}
    
    else {
	Stuermer::Behave();
    }
}

void Pizarro::Behave()
{
    strcpy(MyName,"Pizarro");
    if (Mem->PlayMode == PM_Before_Kick_Off)    
	if(onStartPos)
	    scan_field_with_body();
	else{
	    onStartPos=true;
	    move(-1,-10);
	}
    else {
	Stuermer::Behave();
    }
}
void Frings::Behave()
{
    if (Mem->PlayMode == PM_Before_Kick_Off)
	if(onStartPos)
	    scan_field_with_body();
	else{
	    onStartPos=true;
	    move(-1,-20);
	}
    else {
	Stuermer::Behave();
    }
}

void Bogdanovic::Behave()
{
    strcpy(MyName,"Bogdanovic");
    if (Mem->PlayMode == PM_Before_Kick_Off)
	if(onStartPos)
	    scan_field_with_body();
	else{
	    onStartPos=true;
	    move(-1,1);
	}
    else {
	Stuermer::Behave();
    }
}

void Stalteri::Behave()
{
    strcpy(MyName,"Stalteri");
    if (Mem->PlayMode == PM_Before_Kick_Off)
	if(onStartPos)
	    scan_field_with_body();
	else{
	    onStartPos=true;
	    move(-1,20);
	}
    
    else {
	Stuermer::Behave();
    }
}

void Stuermer::getBall()
{
  if ( !Mem->MyConf() || !Mem->BallPositionValid() ) my_error("not enough info to get ball");

  DodgeType dodge = DT_only_with_ball;

  if ( !Mem->BallMoving() ){
    Mem->LogAction2(30, "get_ball: ball not moving, going to it's pos");
    if ( go_to_point(Mem->BallAbsolutePosition(),0,100,dodge) == AQ_ActionNotQueued ){
      my_error("already there???");
      face_neck_and_body_to_ball();
    }
    face_only_neck_to_ball();
  }
  else {
    if ( !Mem->MyInterceptionAble() ){
      Mem->LogAction2(30, "get_ball: going to the moving ball, but can't?");
      my_error("Can't get to the ball");
      face_neck_and_body_to_ball();
    } else if (Mem->MyInterceptionNumberCycles() == 1) {
      /* we're just one dash away, so just do it */
      Mem->LogAction2(30, "get_ball: going to the moving ball, just dashing 1 cycle");
      dash(Mem->CorrectDashPowerForStamina(Mem->MyInterceptionDashPower()));
      face_only_neck_to_ball();
    } else if ( go_to_point(Mem->MyInterceptionPoint(),0,Mem->MyInterceptionDashPower(),
			    dodge) == AQ_ActionNotQueued ) {
      Mem->LogAction2(30, "get_ball: going to the moving ball, but already there?");
      my_error("already there (moving) ???");
      face_neck_and_body_to_ball();
    } else {
	Mem->LogAction4(30, "get_ball: going to the moving ball (%d) pow %.2f",
			Mem->MyInterceptionNumberCycles(), Mem->MyInterceptionDashPower());
	face_only_neck_to_ball();
    }
  }

}

